#include <bits/stdc++.h>
using namespace std;
int main(){
int n,h;
cin>>h>>n;
int niz[h][n];
int pomniz[n];
for(int i=0;i<n;i++){
    pomniz[i]=1;
}
int levo,desno;
int favlevo,favdesno;
bool bdesno=false,blevo=false,stavidesno=false,stavilevo=false;
for(int i=0;i<h;i++){
    for(int j=0;j<n;j++){
    cin>>niz[i][j];
    }
}
for(int i=0;i<h;i++){
for(int j=0;j<n;j++){
    if(niz[i][j]==0){

        if(pomniz[j]%2==1){
            if((i+1)%2==0) bdesno=true;
            if((i+1)%2==1) blevo=true;
        }
        levo=j-1;
        desno = j+1;
            while(levo>=0){
                if(niz[i][levo]==1){
                favlevo= levo;
                levo=-2;
            }
            levo--;
            }

            if(levo==-1){
                stavidesno=true;
            }
            while(desno<n){
                if(niz[i][desno]==1){
                    favdesno=desno;
                    desno=n+1;

                }
                desno++;
            }
            if(desno==n){
                stavilevo=true;
            }
            if(stavidesno==false && stavilevo==false){
            if(bdesno==true) pomniz[favdesno]++;
            if(blevo==true) pomniz[favlevo]++;
            if(blevo==true || bdesno==true)pomniz[j]--;
            pomniz[favdesno]+=pomniz[j]/2;
            pomniz[favlevo]+=pomniz[j]/2;
            }
            else if(stavidesno==true){ pomniz[favdesno]+=pomniz[j];}
            else if(stavilevo==true){ pomniz[favlevo]+=pomniz[j];}
            pomniz[j]=0;

            stavilevo=false;
            stavidesno=false;
            bdesno=false;
            blevo=false;

    }



}




}
for(int i=0;i<n;i++){
    cout<<pomniz[i]<<" ";
}


}